/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: Timer1_PWM.c
** 		: BLDCd@
**            "BLDC"Ƃł̎gp̂
**
**  :  		  t: : :
** 1.0   2007N126  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/
/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "Timer1_PWM.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

SoftTimer_t time_count_1s;		//!< ebo߂0Ɍ̂Ɏgϐ


/*! @brief Timer1_start͔ro1AłPWMpɌv1\ݒ
 *  vȉ̂悤ɍ\ݒ肵܂B
 *  - vۯFosc(Ou=clk/1)8MHz
 *  - PWMgp
 *  - OC1Aro݂gp
 *  - OC1A0`0CR1A܂Őݒ(1)Ǎ͌v1TOP܂ŉ(0)
 *  - \ݒ肳ꂽg` : v1TOP0x01FF(9ޯČv)
 *  - PWM0%ŊJn
 */
void Timer1_start(void)
{
	// OCR1ArvŔro݉(0)ATOP($01FF)Őݒ(1)
	TCCR1A = (1<<COM1A1) | (1<<WGM11);
	// ro͂ƋɍPWMݒ : PWMg`lATOPvl=$01FFA
	// clk/1Ouˈ(PWM)=64s
	TCCR1B = (1<<WGM12) | (1<<CS10);
	// PWM0ɐݒ
	TIMER1_SET_OC1A_PWM (0x0000);
}


/*! @brief manage_time_base͏dvłȂԐ̂߂ɔwʂŎs
 *  łB
 *  Ԍv͌v1ł̊e64sɌ炳ׂłBԌv
 *  킪0ɒBƁA1so߂܂B׸ނݒ肳Av͍Ăт̏l
 *  ݒ肳܂B
 */
void manage_time_base(void)
{
	if (TIFR1 & (1<<TOV1))					// v1 ?
	{
		if (time_count_1s.count > 0)
			time_count_1s.count--;
		else
		{
			time_count_1s.count = 15625;	// 15625~64s1bv
			time_count_1s.ovf = true;
		}
		TIFR1 |= (1<<TOV1);					// v1׸ ޯĉ
	}
}
